#include <signal.h>

#include "util.h"
#include "wm.h"
#include "cm.h"
#include "mema.h"

static volatile bool stop_loop = false;

static void
signal_handler()
{
    stop_loop = true;
}

int 
main(int argc, char const *argv[])
{
    uint64_t current_update = 0, last_update = 0, accum = 0;
    gmema_init();

    signal(SIGINT, signal_handler);
    signal(SIGTERM, signal_handler);

    cm_init(Mod1Mask);
    
    while(!wm_process_events() && !stop_loop)
    {
        current_update = time_ms();
        accum += current_update - last_update;
        last_update = current_update;

        if(accum >= 16)
        {
            accum = 0;
            cm_render_windows();
        }

        usleep(100);
    }
    cm_destroy();

    // wm_init(Mod1Mask);
    
    // while(!wm_process_events())
    // {
    //     usleep(100);
    // }
    // wm_destroy();
    return 0;
}